// RemoteControlTab.cpp : implementation file
//

#include "stdafx.h"
#include "SensorSim.h"
#include "RemoteControlTab.h"
#include "SensorSimCore.h"
#include "SensorSimDlg.h"
#include "socket.h"
#include "CommonFnc.h"

extern CSensorSimCore*  pSensorSim;
extern CSensorSimDlg*  pSensorSimDlg;

// CRemoteControlTab dialog

IMPLEMENT_DYNAMIC(CRemoteControlTab, CDialog)

CRemoteControlTab::CRemoteControlTab(CWnd* pParent /*=NULL*/)
	: CDialog(CRemoteControlTab::IDD, pParent)
	, m_remoteHosts(_T(""))
{

}

CRemoteControlTab::~CRemoteControlTab()
{
}

void CRemoteControlTab::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_REMOTEHOST_LIST, m_remoteCtrl);
	DDX_Text(pDX, IDC_REMOTEHOSTS_STR, m_remoteHosts);
}


BEGIN_MESSAGE_MAP(CRemoteControlTab, CDialog)
	ON_BN_CLICKED(IDC_BUTTON1, &CRemoteControlTab::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_REFRESH_HOSTS, &CRemoteControlTab::OnBnClickedRefreshHosts)
END_MESSAGE_MAP()

BOOL CRemoteControlTab::OnInitDialog()
{
	CDialog::OnInitDialog();
    m_remoteCtrl.InsertColumn(0, "IP", LVCFMT_LEFT, 80);
    m_remoteCtrl.InsertColumn(1, "identif", LVCFMT_LEFT, 150);
    m_remoteCtrl.InsertColumn(2, "status", LVCFMT_LEFT, 10000);
//    m_remoteCtrl.InsertColumn(2, "result", LVCFMT_LEFT, 100);
    

	return TRUE;
}
int CRemoteControlTab::GetDlgData(BASIC_INIT_DATA* pBasicSettings) {
    int status = STAT_OK;
    
    UpdateData(TRUE);

    // VALUES STORED FROM CSavedCharsDlg
    pBasicSettings->remoteConfig.remoteHosts = m_remoteHosts;


    return status;
}

int CRemoteControlTab::SetDlgData(BASIC_INIT_DATA* pBasicSettings) {
    int status = STAT_OK;

	// VALUES STORED  
    m_remoteHosts = pBasicSettings->remoteConfig.remoteHosts;

	// REFRESH HOSTS
	RefreshHosts(m_remoteHosts, FALSE);

    UpdateData(FALSE);

    return status;
}

int CRemoteControlTab::RefreshHosts(CString hostsIP, BOOL bAskProxy) {
    int     status = STAT_OK;
    int     pos = 0;
    int     pos2 = 0;
	CString message;
	CString IP;
    CString port;
	lcs::iterator	iter;

    UpdateData(TRUE);   

    hostsIP += ";";

    // SET LIST OF AVAILABLE HOSTS FOR TASKS
	CComboBox*  pCombo = (CComboBox*) pSensorSimDlg->GetDlgItem(IDC_COMBO_HOSTPC);
    pCombo->ResetContent();

	// PARSE IP STRING, TRY TO PING DEVICES
    m_remoteList.clear();
	while ((pos2 = hostsIP.Find(";", pos)) != -1) {
        IP = "";
        message = hostsIP.Mid(pos, pos2 - pos);
        if (message != "") {
			// VALID IP FOUND, TRY TO CONNECT AND OBTAIN STATUS
			m_remoteList.push_back(message);
            pCombo->AddString(message);
		}
                
        pos = pos2 + 1;
	}
    // SELECT HOST_ACTUAL IDENTIFICATION
    pCombo->AddString(HOST_ACTUAL);
    if ((pos = pCombo->FindStringExact(0, HOST_ACTUAL)) >= 0) {
        pCombo->SetCurSel(pos);
    }
    else pCombo->SetCurSel(0);


    if (bAskProxy) {
	    m_remoteCtrl.DeleteAllItems();
	    for (iter = m_remoteList.begin(); iter != m_remoteList.end(); iter++) {
            message = *iter;
		    IP = message.Left(message.Find(":"));
            port = message.Right(message.GetLength() - message.Find(":") - 1);
    		
		    // GET&SET INFO ABOUT RUNNING PROCESSES
		    lhi				hostsInfo;
		    lhi::iterator	iter2;
		    if (GetRemoteHostInfo(IP, atoi(port), &hostsInfo) == STAT_OK) {
			    int	index;

			    for (iter2 = hostsInfo.begin(); iter2 != hostsInfo.end(); iter2++) {
				    REMOTE_HOST_INFO	hostInfo = *iter2;		
				    index = m_remoteCtrl.InsertItem(0, hostInfo.IP, 0);
				    m_remoteCtrl.SetItem(index, 1,  LVIF_TEXT, hostInfo.identif, 1, LVIF_STATE, 1, 1); 
				    m_remoteCtrl.SetItem(index, 2,  LVIF_TEXT, hostInfo.status, 1, LVIF_STATE, 1, 1); 
    //				m_remoteCtrl.SetItem(index, 3,  LVIF_TEXT, hostInfo.actResult, 1, LVIF_STATE, 1, 1); 
			    }
		    }
	    }
    }
    
	return status;
}
	// CRemoteControlTab message handlers

int CRemoteControlTab::GetRemoteHostInfo(CString IP, int port, lhi* pHostsList) {
	int				status = STAT_OK;
	SocketClient*	pSocket = NULL;
	REMOTE_HOST_INFO	remoteInfo;
	CString				response;
	CString				request; 

	// try to connect to proxy on remote computer
	try {
		if ((pSocket = new SocketClient((LPCTSTR) IP, port)) != NULL) {
			// OBTAIN ALL RUNNING INSTANCES
			lcs					appList;
			lcs::iterator		iter;
			CString				retStat;
			if (pSensorSim->m_proxy.SocketSendLine(pSocket, "getInstances#", &response, &retStat) == STAT_OK) {
				CCommonFnc::String_ParseSeparatedArray(response, "#", &appList);
				for (iter = appList.begin(); iter != appList.end(); iter++) {
					// PARSE INFORMATION ABOUT RUNNING INSTANCES
					remoteInfo.clear();
					remoteInfo.IP = IP;
					// identif:status 
					int pos = iter->Find(PROXY_VALUE_SEPARATOR);
					remoteInfo.identif = iter->Left(pos); 
					int pos2 = iter->Find(PROXY_VALUE_SEPARATOR, pos + 1);
					remoteInfo.status = iter->Mid(pos + 1, pos2 - pos - 1); 
//					remoteInfo.date = ;

	/*
					// GET INFO ABOUT GIVEN INSTANCE
					request.Format("getFileContent#%s#actResult.txt#", remoteInfo.identif);
					if (pSensorSim->m_proxy.SocketSendLine(pSocket, request, &response)) {
						remoteInfo.actResult = response;
					}
					request.Format("getFileContent#%s#status.txt#", remoteInfo.identif);
					if (pSensorSim->m_proxy.SocketSendLine(pSocket, request, &response)) {
						remoteInfo.status = response;
					}
	/**/				
					pHostsList->push_back(remoteInfo);
				}
			}
		}
		else {
			// UNABLE TO CONNECT
			remoteInfo.clear();
			remoteInfo.IP = IP;
			remoteInfo.status = "fail to connect";
			pHostsList->push_back(remoteInfo);
		}

		// disconnect
		request.Format("%s%s", PROXY_DISCONNECT, PROXY_SEPARATOR);
		pSensorSim->m_proxy.SocketSendLine(pSocket, request, &response);
		delete pSocket;
	}
	catch (...) {
		// UNABLE TO CONNECT
		remoteInfo.clear();
		remoteInfo.IP = IP;
		remoteInfo.status = "fail to connect";
		pHostsList->push_back(remoteInfo);

		status = STAT_CHANNEL_NOT_EXISTS;	
	}
	return status;
}
	

void CRemoteControlTab::OnBnClickedButton1()
{
	SocketClient* pSocket = new SocketClient("127.0.0.1", 4001);	
//	pSocket->SendLine("setFileContent#pokus.txt#10#\n1234567890");
//	pSocket->SendLine("runApplication#sacc.exe##");
	pSocket->SendLine("getRunApplication#sacc.exe##");

    string l = pSocket->ReceiveResponse(SCSAT_SOCKET_ENDSEQ, SCSAT_SOCKET_TIMEOUT);
	CString data = l.c_str();

	delete pSocket;
}

void CRemoteControlTab::OnBnClickedRefreshHosts()
{
	int		status = STAT_OK;

	UpdateData(TRUE);
	BASIC_INIT_DATA	basicSettings;

	// SAVE ONLY HOSTS STRING
    if ((status = pSensorSim->m_sensorEnv.LoadConfigScript(pSensorSim->m_defaultCfgFile, &basicSettings)) == STAT_OK) {
		basicSettings.remoteConfig.remoteHosts = m_remoteHosts;
        status = pSensorSim->m_sensorEnv.SaveConfigScript(pSensorSim->m_defaultCfgFile, &basicSettings);
    }

	// UPDATE HOSTS
	RefreshHosts(m_remoteHosts, TRUE);
}
