#ifndef CSCRIPTACTION_H
#define CSCRIPTACTION_H

class CNewKeyAction: public CAction {
private:
    SENSITIVE_OBJECT**   ppKey;
    int                  ppKeyPtrIndex;
public:
    CNewKeyAction(int keyPtrIndex);
    int TryAssignPointer(PTR_TYPE ptrType, int ptrIndex, void* pPtr);
    int Execute();
    int CheckPointerCorrectness();
};

class CAddKeyAction: public CAction {
private:
    SENSITIVE_OBJECT**   ppKey;
    int                  ppKeyPtrIndex;
    SENSOR_NODE*         pSensor;
    int                  pSensorPtrIndex;
public:
    CAddKeyAction(int keyPtrIndex, int sensorPtrIndex);
    int TryAssignPointer(PTR_TYPE ptrType, int ptrIndex, void* pPtr);
    int Execute();
    int CheckPointerCorrectness();
};

class CCombineKeysAction: public CAction {
private:
    SENSITIVE_OBJECT**   ppKey1;
    int                  ppKey1PtrIndex;
    SENSITIVE_OBJECT**   ppKey2;
    int                  ppKey2PtrIndex;
    SENSITIVE_OBJECT**   ppKeyComposite;
    int                  ppKeyCompositePtrIndex;
public:
    CCombineKeysAction(int key1PtrIndex, int key2PtrIndex, int keyCompositePtrIndex);
    int TryAssignPointer(PTR_TYPE ptrType, int ptrIndex, void* pPtr);
    int Execute();
    int CheckPointerCorrectness();
};

class CNewMessageAction_noKey: public CAction {
private:
    SENSITIVE_OBJECT**   ppContent;
    int                  ppContentPtrIndex;
    SENSITIVE_OBJECT**   ppMessage;
    int                  ppMessagePtrIndex;
public:
    CNewMessageAction_noKey(int contentPtrIndex, int messagePtrIndex);
    int TryAssignPointer(PTR_TYPE ptrType, int ptrIndex, void* pPtr);
    int Execute();
    int CheckPointerCorrectness();
};

class CNewMessageAction_oneKey: public CAction {
private:
    SENSITIVE_OBJECT**   ppContent;
    int                  ppContentPtrIndex;
    SENSITIVE_OBJECT**   ppKey;
    int                  ppKeyPtrIndex;
    SENSITIVE_OBJECT**   ppMessage;
    int                  ppMessagePtrIndex;
public:
    CNewMessageAction_oneKey(int contentPtrIndex, int keyPtrIndex, int messagePtrIndex);
    int TryAssignPointer(PTR_TYPE ptrType, int ptrIndex, void* pPtr);
    int Execute();
    int CheckPointerCorrectness();
};

class CSendMessageAction: public CAction {
private:
    SENSOR_NODE*         pSenderNode;
    int                  pSenderNodePtrIndex;
    SENSOR_NODE*         pTargetNode;
    int                  pTargetNodePtrIndex;
    SENSITIVE_OBJECT**   ppMessage;
    int                  ppMessagePtrIndex;
public:
    CSendMessageAction(int senderPtrIndex, int targetPtrIndex, int messagePtrIndex);
    int TryAssignPointer(PTR_TYPE ptrType, int ptrIndex, void* pPtr);
    int Execute();
    int CheckPointerCorrectness();
};

class CDispatchMessageAction: public CAction {
private:
    SENSOR_NODE*         pNode;
    int                  pNodePtrIndex;
public:
    CDispatchMessageAction(int nodePtrIndex);
    int TryAssignPointer(PTR_TYPE ptrType, int ptrIndex, void* pPtr);
    int Execute();
    int CheckPointerCorrectness();
};


#endif 