// SensorSim.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "SensorSim.h"
#include "SensorSimDlg.h"
#include "SensorSimCore.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSensorSimApp

BEGIN_MESSAGE_MAP(CSensorSimApp, CWinApp)
	//{{AFX_MSG_MAP(CSensorSimApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
	ON_THREAD_MESSAGE(WM_LOG_INSERTSTRING, OnLogInsertString)
	ON_THREAD_MESSAGE(WM_CLOSE, OnClose)
	ON_THREAD_MESSAGE(WM_THREAD_ENDED, OnThreadEnded)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

CSensorSimApp::CSensorSimApp()
{
	pSensorSim = NULL;
	pSensorSimDlg = NULL;
}

CSensorSimApp::~CSensorSimApp()
{
	DestroyApp();
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSensorSimApp object

CSensorSimApp theApp;
extern ATOM RegisterClassS3Graph(HINSTANCE hInstance);

/////////////////////////////////////////////////////////////////////////////
// CSensorSimApp initialization

BOOL CSensorSimApp::InitInstance()
{
	pSensorSim = new CSensorSimCore;
	pSensorSim->HandleCommandLine();
	if (pSensorSim->m_visible) {
		// Standard initialization
		// If you are not using these features and wish to reduce the size
		//  of your final executable, you should remove from the following
		//  the specific initialization routines you do not need.

	#ifdef _AFXDLL
		Enable3dControls();			// Call this when using MFC in a shared DLL
	#else
	//	Enable3dControlsStatic();	// Call this when linking to MFC statically
	#endif

		GdiplusStartupInput gdiplusStartupInput;
		ULONG_PTR           gdiplusToken;
		GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);

		RegisterClassS3Graph(this->m_hInstance);

		pSensorSimDlg = new CSensorSimDlg;		
		m_pMainWnd = pSensorSimDlg;

		BOOL ret = pSensorSimDlg->Create(IDD_SENSORSIM_DIALOG, NULL);

		if (!ret) {   //Create failed.
			 AfxMessageBox(_T("Error creating SensorSimDlg"));
			 return FALSE;
		} else 
			pSensorSimDlg->ShowWindow(SW_SHOW);
	}

	pSensorSim->Run();
	
	return TRUE;
}

int CSensorSimApp::Run() {
	return CWinThread::Run();
}

void CSensorSimApp::DestroyApp()
{
	if (pSensorSimDlg != NULL){
		if (IsWindow(pSensorSimDlg->m_hWnd))
			pSensorSimDlg->CloseWindow();		
		pSensorSimDlg->DestroyWindow();
		delete pSensorSimDlg;
		pSensorSimDlg = NULL;
	}
	if (pSensorSim != NULL){
		delete pSensorSim;
		pSensorSim = NULL;
	}
}

int CSensorSimApp::ExitInstance(){	
	DestroyApp();
	return CWinApp::ExitInstance();
}

void CSensorSimApp::OnLogInsertString(WPARAM wParam, LPARAM lParam) {
	if (pSensorSim)
		pSensorSim->OnLogInsertString(wParam, lParam);
}
void CSensorSimApp::OnThreadEnded(WPARAM wParam, LPARAM lParam) {
	CString message;
	message.Format("Repeat %d elapsed, total repetitions %d", pSensorSim->m_numRepetitionsElapsed, pSensorSim->m_numRepetitions);
	LOG_INSERTSTRING(message);

	pSensorSim->m_numRepetitionsElapsed++;
	// Change file with starting population to intermediate population 
	pSensorSim->m_defaultPopulationFile = "population.ini";

	// Run new repetition
	if (pSensorSim) pSensorSim->Run();
}


void CSensorSimApp::OnClose(WPARAM wParam, LPARAM lParam){
	AfxPostQuitMessage(0);
}
